/**
* marked - a markdown parser
* Copyright (c) 2011-2018, Christopher Jeffrey. (MIT Licensed)
* https://github.com/markedjs/marked
*/
const eml = new Map();
eml.set('note', '26a0');eml.set('alembic', '2697');eml.set('balance_scale', '2696');eml.set('coffin', '26b0');eml.set('control_knobs', '1f39b');eml.set('crab', '1f980');eml.set('fox_face', '1f98a');eml.set('framed_picture', '1f5bc');eml.set('gear', '2699');eml.set('heavy_heart_exclamation', '2763');eml.set('label', '1f3f7');eml.set('lizard', '1f98e');eml.set('loud_sound', '1f50a');eml.set('nerd_face', '1f913');eml.set('rainbow_flag', '1f3f3-1f308');eml.set('robot', '1f916');eml.set('roll_eyes', '1f644');eml.set('sauropod', '1f995');eml.set('speaking_head', '1f5e3');eml.set('thermometer', '1f321');eml.set('simple_smile', '1f642');eml.set('joystick', '1f579');eml.set('black_large_square', '2b1b');eml.set('black_medium_small_square', '25fe');eml.set('black_medium_square', '25fc');eml.set('black_small_square', '25aa');eml.set('white_large_square', '2b1c');eml.set('white_medium_small_square', '25fd');eml.set('white_medium_square', '25fb');eml.set('white_small_square', '25ab');eml.set('thinking', '1f914');eml.set('+1', '1f44d');eml.set('thumbsup', '1f44d');eml.set('-1', '1f44e');eml.set('thumbsdown', '1f44e');eml.set('100', '1f4af');eml.set('1234', '1f522');eml.set('8ball', '1f3b1');eml.set('a', '1f170');eml.set('ab', '1f18e');eml.set('abc', '1f524');eml.set('abcd', '1f521');eml.set('accept', '1f251');eml.set('aerial_tramway', '1f6a1');eml.set('airplane', '2708');eml.set('alarm_clock', '23f0');eml.set('alien', '1f47d');eml.set('ambulance', '1f691');eml.set('anchor', '2693');eml.set('angel', '1f47c');eml.set('anger', '1f4a2');eml.set('angry', '1f620');eml.set('anguished', '1f627');eml.set('ant', '1f41c');eml.set('apple', '1f34e');eml.set('aquarius', '2652');eml.set('aries', '2648');eml.set('arrow_backward', '25c0');eml.set('arrow_double_down', '23ec');eml.set('arrow_double_up', '23eb');eml.set('arrow_down', '2b07');eml.set('arrow_down_small', '1f53d');eml.set('arrow_forward', '25b6');eml.set('arrow_heading_down', '2935');eml.set('arrow_heading_up', '2934');eml.set('arrow_left', '2b05');eml.set('arrow_lower_left', '2199');eml.set('arrow_lower_right', '2198');eml.set('arrow_right', '27a1');eml.set('arrow_right_hook', '21aa');eml.set('arrow_up', '2b06');eml.set('arrow_up_down', '2195');eml.set('arrow_up_small', '1f53c');eml.set('arrow_upper_left', '2196');eml.set('arrow_upper_right', '2197');eml.set('arrows_clockwise', '1f503');eml.set('arrows_counterclockwise', '1f504');eml.set('art', '1f3a8');eml.set('articulated_lorry', '1f69b');eml.set('astonished', '1f632');eml.set('atm', '1f3e7');eml.set('b', '1f171');eml.set('baby', '1f476');eml.set('baby_bottle', '1f37c');eml.set('baby_chick', '1f424');eml.set('baby_symbol', '1f6bc');eml.set('baggage_claim', '1f6c4');eml.set('balloon', '1f388');eml.set('ballot_box_with_check', '2611');eml.set('banana', '1f34c');eml.set('bangbang', '203c');eml.set('bank', '1f3e6');eml.set('bar_chart', '1f4ca');eml.set('barber', '1f488');eml.set('baseball', '26be');eml.set('basketball', '1f3c0');eml.set('bath', '1f6c0');eml.set('bathtub', '1f6c1');eml.set('battery', '1f50b');eml.set('bear', '1f43b');eml.set('honeybee', '1f41d');eml.set('beer', '1f37a');eml.set('beers', '1f37b');eml.set('beetle', '1fab2');eml.set('beginner', '1f530');eml.set('bell', '1f514');eml.set('bento', '1f371');eml.set('bicyclist', '1f6b4');eml.set('bike', '1f6b2');eml.set('bikini', '1f459');eml.set('bird', '1f426');eml.set('birthday', '1f382');eml.set('black_circle', '26ab');eml.set('black_joker', '1f0cf');eml.set('black_nib', '2712');eml.set('black_square_button', '1f532');eml.set('blossom', '1f33c');eml.set('blowfish', '1f421');eml.set('blue_book', '1f4d8');eml.set('blue_car', '1f699');eml.set('blue_heart', '1f499');eml.set('blush', '1f60a');eml.set('boar', '1f417');eml.set('boat', '26f5');eml.set('sailboat', '26f5');eml.set('bomb', '1f4a3');eml.set('book', '1f4d6');eml.set('bookmark', '1f516');eml.set('bookmark_tabs', '1f4d1');eml.set('books', '1f4da');eml.set('boom', '1f4a5');eml.set('collision', '1f4a5');eml.set('boot', '1f462');eml.set('bouquet', '1f490');eml.set('bow', '1f647');eml.set('bowling', '1f3b3');eml.set('boy', '1f466');eml.set('bread', '1f35e');eml.set('bridge_at_night', '1f309');eml.set('briefcase', '1f4bc');eml.set('broken_heart', '1f494');eml.set('bug', '1f41b');eml.set('bulb', '1f4a1');eml.set('bullettrain_front', '1f685');eml.set('bullettrain_side', '1f684');eml.set('bus', '1f68c');eml.set('busstop', '1f68f');eml.set('bust_in_silhouette', '1f464');eml.set('busts_in_silhouette', '1f465');eml.set('cactus', '1f335');eml.set('cake', '1f370');eml.set('calendar', '1f4c6');eml.set('calling', '1f4f2');eml.set('camel', '1f42b');eml.set('camera', '1f4f7');eml.set('cancer', '264b');eml.set('candy', '1f36c');eml.set('capital_abcd', '1f520');eml.set('capricorn', '2651');eml.set('car', '1f697');eml.set('red_car', '1f697');eml.set('card_index', '1f4c7');eml.set('carousel_horse', '1f3a0');eml.set('cat', '1f431');eml.set('cat2', '1f408');eml.set('cd', '1f4bf');eml.set('chart', '1f4b9');eml.set('chart_with_downwards_trend', '1f4c9');eml.set('chart_with_upwards_trend', '1f4c8');eml.set('checkered_flag', '1f3c1');eml.set('cherries', '1f352');eml.set('cherry_blossom', '1f338');eml.set('chestnut', '1f330');eml.set('chicken', '1f414');eml.set('children_crossing', '1f6b8');eml.set('chocolate_bar', '1f36b');eml.set('christmas_tree', '1f384');eml.set('church', '26ea');eml.set('cinema', '1f3a6');eml.set('circus_tent', '1f3aa');eml.set('city_sunrise', '1f307');eml.set('city_sunset', '1f306');eml.set('cl', '1f191');eml.set('clap', '1f44f');eml.set('clapper', '1f3ac');eml.set('clipboard', '1f4cb');eml.set('clock1', '1f550');eml.set('clock10', '1f559');eml.set('clock1030', '1f565');eml.set('clock11', '1f55a');eml.set('clock1130', '1f566');eml.set('clock12', '1f55b');eml.set('clock1230', '1f567');eml.set('clock130', '1f55c');eml.set('clock2', '1f551');eml.set('clock230', '1f55d');eml.set('clock3', '1f552');eml.set('clock330', '1f55e');eml.set('clock4', '1f553');eml.set('clock430', '1f55f');eml.set('clock5', '1f554');eml.set('clock530', '1f560');eml.set('clock6', '1f555');eml.set('clock630', '1f561');eml.set('clock7', '1f556');eml.set('clock730', '1f562');eml.set('clock8', '1f557');eml.set('clock830', '1f563');eml.set('clock9', '1f558');eml.set('clock930', '1f564');eml.set('closed_book', '1f4d5');eml.set('closed_lock_with_key', '1f510');eml.set('closed_umbrella', '1f302');eml.set('clubs', '2663');eml.set('cn', '1f1e8-1f1f3');eml.set('cocktail', '1f378');eml.set('coffee', '2615');eml.set('cold_sweat', '1f630');eml.set('computer', '1f4bb');eml.set('confetti_ball', '1f38a');eml.set('confounded', '1f616');eml.set('confused', '1f615');eml.set('congratulations', '3297');eml.set('construction', '1f6a7');eml.set('construction_worker', '1f477');eml.set('convenience_store', '1f3ea');eml.set('cookie', '1f36a');eml.set('cool', '1f192');eml.set('copyright', '00a9');eml.set('corn', '1f33d');eml.set('couple', '1f46b');eml.set('couple_with_heart', '1f491');eml.set('couplekiss', '1f48f');eml.set('cow', '1f42e');eml.set('cow2', '1f404');eml.set('credit_card', '1f4b3');eml.set('crocodile', '1f40a');eml.set('crossed_flags', '1f38c');eml.set('crown', '1f451');eml.set('cry', '1f622');eml.set('crying_cat_face', '1f63f');eml.set('crystal_ball', '1f52e');eml.set('cupid', '1f498');eml.set('curly_loop', '27b0');eml.set('currency_exchange', '1f4b1');eml.set('curry', '1f35b');eml.set('custard', '1f36e');eml.set('customs', '1f6c3');eml.set('cyclone', '1f300');eml.set('dancers', '1f46f');eml.set('dango', '1f361');eml.set('dart', '1f3af');eml.set('dash', '1f4a8');eml.set('date', '1f4c5');eml.set('de', '1f1e9-1f1ea');eml.set('deciduous_tree', '1f333');eml.set('department_store', '1f3ec');eml.set('diamond_shape_with_a_dot_inside', '1f4a0');eml.set('diamonds', '2666');eml.set('disappointed', '1f61e');eml.set('disappointed_relieved', '1f625');eml.set('dizzy', '1f4ab');eml.set('dizzy_face', '1f635');eml.set('do_not_litter', '1f6af');eml.set('dog', '1f436');eml.set('dog2', '1f415');eml.set('dollar', '1f4b5');eml.set('dolphin', '1f42c');eml.set('door', '1f6aa');eml.set('doughnut', '1f369');eml.set('dragon', '1f409');eml.set('dragon_face', '1f432');eml.set('dress', '1f457');eml.set('dromedary_camel', '1f42a');eml.set('droplet', '1f4a7');eml.set('dvd', '1f4c0');eml.set('ear', '1f442');eml.set('ear_of_rice', '1f33e');eml.set('earth_africa', '1f30d');eml.set('earth_americas', '1f30e');eml.set('earth_asia', '1f30f');eml.set('egg', '1f95a');eml.set('eggplant', '1f346');eml.set('eight', '0038-20e3');eml.set('eight_pointed_black_star', '2734');eml.set('eight_spoked_asterisk', '2733');eml.set('electric_plug', '1f50c');eml.set('elephant', '1f418');eml.set('e-mail', '1f4e7');eml.set('email', '1f4e7');eml.set('end', '1f51a');eml.set('envelope', '2709');eml.set('es', '1f1ea-1f1f8');eml.set('euro', '1f4b6');eml.set('european_castle', '1f3f0');eml.set('european_post_office', '1f3e4');eml.set('evergreen_tree', '1f332');eml.set('exclamation', '2757');eml.set('heavy_exclamation_mark', '2757');eml.set('expressionless', '1f611');eml.set('eyeglasses', '1f453');eml.set('eyes', '1f440');eml.set('factory', '1f3ed');eml.set('fallen_leaf', '1f342');eml.set('family', '1f46a');eml.set('fast_forward', '23e9');eml.set('fax', '1f4e0');eml.set('fearful', '1f628');eml.set('feet', '1f43e');eml.set('paw_prints', '1f43e');eml.set('ferris_wheel', '1f3a1');eml.set('file_folder', '1f4c1');eml.set('fire', '1f525');eml.set('fire_engine', '1f692');eml.set('fireworks', '1f386');eml.set('first_quarter_moon', '1f313');eml.set('first_quarter_moon_with_face', '1f31b');eml.set('fish', '1f41f');eml.set('fish_cake', '1f365');eml.set('fishing_pole_and_fish', '1f3a3');eml.set('facepunch', '1f44a');eml.set('punch', '1f44a');eml.set('fist', '270a');eml.set('five', '0035-20e3');eml.set('flags', '1f38f');eml.set('flashlight', '1f526');eml.set('floppy_disk', '1f4be');eml.set('flower_playing_cards', '1f3b4');eml.set('flushed', '1f633');eml.set('foggy', '1f301');eml.set('football', '1f3c8');eml.set('fork_and_knife', '1f374');eml.set('fountain', '26f2');eml.set('four', '0034-20e3');eml.set('four_leaf_clover', '1f340');eml.set('fr', '1f1eb-1f1f7');eml.set('free', '1f193');eml.set('fried_shrimp', '1f364');eml.set('fries', '1f35f');eml.set('frog', '1f438');eml.set('frowning', '1f626');eml.set('fuelpump', '26fd');eml.set('full_moon', '1f315');eml.set('full_moon_with_face', '1f31d');eml.set('game_die', '1f3b2');eml.set('gb', '1f1ec-1f1e7');eml.set('uk', '1f1ec-1f1e7');eml.set('gem', '1f48e');eml.set('gemini', '264a');eml.set('ghost', '1f47b');eml.set('gift', '1f381');eml.set('girl', '1f467');eml.set('globe_with_meridians', '1f310');eml.set('goat', '1f410');eml.set('golf', '26f3');eml.set('grapes', '1f347');eml.set('green_apple', '1f34f');eml.set('green_book', '1f4d7');eml.set('green_heart', '1f49a');eml.set('grey_exclamation', '2755');eml.set('grey_question', '2754');eml.set('grimacing', '1f62c');eml.set('grin', '1f601');eml.set('grinning', '1f600');eml.set('guardsman', '1f482-2642');eml.set('guitar', '1f3b8');eml.set('gun', '1f52b');eml.set('haircut', '1f487');eml.set('hamburger', '1f354');eml.set('hammer', '1f528');eml.set('hamster', '1f439');eml.set('hand', '270b');eml.set('raised_hand', '270b');eml.set('handbag', '1f45c');eml.set('hankey', '1f4a9');eml.set('poop', '1f4a9');eml.set('shit', '1f4a9');eml.set('hash', '0023-20e3');eml.set('hatched_chick', '1f425');eml.set('hatching_chick', '1f423');eml.set('headphones', '1f3a7');eml.set('hear_no_evil', '1f649');eml.set('heart', '2764');eml.set('heart_decoration', '1f49f');eml.set('heart_eyes', '1f60d');eml.set('heart_eyes_cat', '1f63b');eml.set('heartbeat', '1f493');eml.set('heartpulse', '1f497');eml.set('hearts', '2665');eml.set('heavy_check_mark', '2714');eml.set('heavy_division_sign', '2797');eml.set('heavy_dollar_sign', '1f4b2');eml.set('heavy_minus_sign', '2796');eml.set('heavy_multiplication_x', '2716');eml.set('heavy_plus_sign', '2795');eml.set('helicopter', '1f681');eml.set('herb', '1f33f');eml.set('hibiscus', '1f33a');eml.set('high_brightness', '1f506');eml.set('high_heel', '1f460');eml.set('hocho', '1f52a');eml.set('honey_pot', '1f36f');eml.set('horse', '1f434');eml.set('horse_racing', '1f3c7');eml.set('hospital', '1f3e5');eml.set('hotel', '1f3e8');eml.set('hotsprings', '2668');eml.set('hourglass', '231b');eml.set('hourglass_flowing_sand', '23f3');eml.set('hushed', '1f62f');eml.set('ice_cream', '1f368');eml.set('icecream', '1f366');eml.set('id', '1f194');eml.set('ideograph_advantage', '1f250');eml.set('imp', '1f47f');eml.set('inbox_tray', '1f4e5');eml.set('incoming_envelope', '1f4e8');eml.set('information_source', '2139');eml.set('innocent', '1f607');eml.set('interrobang', '2049');eml.set('iphone', '1f4f1');eml.set('it', '1f1ee-1f1f9');eml.set('izakaya_lantern', '1f3ee');eml.set('jack_o_lantern', '1f383');eml.set('japan', '1f5fe');eml.set('japanese_castle', '1f3ef');eml.set('japanese_goblin', '1f47a');eml.set('japanese_ogre', '1f479');eml.set('jeans', '1f456');eml.set('joy', '1f602');eml.set('joy_cat', '1f639');eml.set('jp', '1f1ef-1f1f5');eml.set('key', '1f511');eml.set('keycap_ten', '1f51f');eml.set('kimono', '1f458');eml.set('kiss', '1f48b');eml.set('kissing', '1f617');eml.set('kissing_cat', '1f63d');eml.set('kissing_closed_eyes', '1f61a');eml.set('kissing_heart', '1f618');eml.set('kissing_smiling_eyes', '1f619');eml.set('koala', '1f428');eml.set('koko', '1f201');eml.set('kr', '1f1f0-1f1f7');eml.set('large_blue_circle', '1f535');eml.set('large_blue_diamond', '1f537');eml.set('large_orange_diamond', '1f536');eml.set('last_quarter_moon', '1f317');eml.set('last_quarter_moon_with_face', '1f31c');eml.set('satisfied', '1f606');eml.set('leaves', '1f343');eml.set('ledger', '1f4d2');eml.set('left_luggage', '1f6c5');eml.set('left_right_arrow', '2194');eml.set('leftwards_arrow_with_hook', '21a9');eml.set('lemon', '1f34b');eml.set('leo', '264c');eml.set('leopard', '1f406');eml.set('libra', '264e');eml.set('light_rail', '1f688');eml.set('link', '1f517');eml.set('lips', '1f444');eml.set('lipstick', '1f484');eml.set('lock', '1f512');eml.set('lock_with_ink_pen', '1f50f');eml.set('lollipop', '1f36d');eml.set('loop', '27bf');eml.set('loudspeaker', '1f4e2');eml.set('love_hotel', '1f3e9');eml.set('love_letter', '1f48c');eml.set('low_brightness', '1f505');eml.set('m', '24c2');eml.set('mag', '1f50d');eml.set('mag_right', '1f50e');eml.set('mahjong', '1f004');eml.set('mailbox', '1f4eb');eml.set('mailbox_closed', '1f4ea');eml.set('mailbox_with_mail', '1f4ec');eml.set('mailbox_with_no_mail', '1f4ed');eml.set('man', '1f468');eml.set('man_with_gua_pi_mao', '1f472');eml.set('man_with_turban', '1f473-2642');eml.set('mans_shoe', '1f45e');eml.set('shoe', '1f45e');eml.set('maple_leaf', '1f341');eml.set('mask', '1f637');eml.set('massage', '1f486');eml.set('meat_on_bone', '1f356');eml.set('mega', '1f4e3');eml.set('melon', '1f348');eml.set('memo', '1f4dd');eml.set('pencil', '1f4dd');eml.set('mens', '1f6b9');eml.set('metal', '1f918');eml.set('metro', '1f687');eml.set('microphone', '1f3a4');eml.set('microscope', '1f52c');eml.set('fu', '1f595');eml.set('milky_way', '1f30c');eml.set('minibus', '1f690');eml.set('minidisc', '1f4bd');eml.set('mobile_phone_off', '1f4f4');eml.set('money_with_wings', '1f4b8');eml.set('moneybag', '1f4b0');eml.set('monkey', '1f412');eml.set('monkey_face', '1f435');eml.set('monorail', '1f69d');eml.set('moon', '1f314');eml.set('waxing_gibbous_moon', '1f314');eml.set('mortar_board', '1f393');eml.set('mount_fuji', '1f5fb');eml.set('mountain_bicyclist', '1f6b5');eml.set('mountain_cableway', '1f6a0');eml.set('mountain_railway', '1f69e');eml.set('mouse', '1f42d');eml.set('mouse2', '1f401');eml.set('movie_camera', '1f3a5');eml.set('moyai', '1f5ff');eml.set('muscle', '1f4aa');eml.set('mushroom', '1f344');eml.set('musical_keyboard', '1f3b9');eml.set('musical_note', '1f3b5');eml.set('musical_score', '1f3bc');eml.set('mute', '1f507');eml.set('nail_care', '1f485');eml.set('name_badge', '1f4db');eml.set('necktie', '1f454');eml.set('negative_squared_cross_mark', '274e');eml.set('neutral_face', '1f610');eml.set('new', '1f195');eml.set('new_moon', '1f311');eml.set('new_moon_with_face', '1f31a');eml.set('newspaper', '1f4f0');eml.set('ng', '1f196');eml.set('nine', '0039-20e3');eml.set('no_bell', '1f515');eml.set('no_bicycles', '1f6b3');eml.set('no_entry', '26d4');eml.set('no_entry_sign', '1f6ab');eml.set('no_good', '1f645');eml.set('no_mobile_phones', '1f4f5');eml.set('no_mouth', '1f636');eml.set('no_pedestrians', '1f6b7');eml.set('no_smoking', '1f6ad');eml.set('non-potable_water', '1f6b1');eml.set('nose', '1f443');eml.set('notebook', '1f4d3');eml.set('notebook_with_decorative_cover', '1f4d4');eml.set('notes', '1f3b6');eml.set('nut_and_bolt', '1f529');eml.set('o', '2b55');eml.set('o2', '1f17e');eml.set('ocean', '1f30a');eml.set('octopus', '1f419');eml.set('oden', '1f362');eml.set('office', '1f3e2');eml.set('ok', '1f197');eml.set('ok_hand', '1f44c');eml.set('ok_woman', '1f646-2640');eml.set('older_man', '1f474');eml.set('older_woman', '1f475');eml.set('on', '1f51b');eml.set('oncoming_automobile', '1f698');eml.set('oncoming_bus', '1f68d');eml.set('oncoming_police_car', '1f694');eml.set('oncoming_taxi', '1f696');eml.set('open_file_folder', '1f4c2');eml.set('open_hands', '1f450');eml.set('open_mouth', '1f62e');eml.set('ophiuchus', '26ce');eml.set('orange_book', '1f4d9');eml.set('outbox_tray', '1f4e4');eml.set('ox', '1f402');eml.set('page_facing_up', '1f4c4');eml.set('page_with_curl', '1f4c3');eml.set('pager', '1f4df');eml.set('palm_tree', '1f334');eml.set('panda_face', '1f43c');eml.set('paperclip', '1f4ce');eml.set('parking', '1f17f');eml.set('part_alternation_mark', '303d');eml.set('partly_sunny', '26c5');eml.set('passport_control', '1f6c2');eml.set('peach', '1f351');eml.set('pear', '1f350');eml.set('pencil2', '270f');eml.set('penguin', '1f427');eml.set('pensive', '1f614');eml.set('performing_arts', '1f3ad');eml.set('persevere', '1f623');eml.set('phone', '260e');eml.set('telephone', '260e');eml.set('pig', '1f437');eml.set('pig2', '1f416');eml.set('pig_nose', '1f43d');eml.set('pill', '1f48a');eml.set('pineapple', '1f34d');eml.set('pisces', '2653');eml.set('pizza', '1f355');eml.set('point_down', '1f447');eml.set('point_left', '1f448');eml.set('point_right', '1f449');eml.set('point_up', '261d');eml.set('point_up_2', '1f446');eml.set('police_car', '1f693');eml.set('cop', '1f46e');eml.set('poodle', '1f429');eml.set('post_office', '1f3e3');eml.set('postal_horn', '1f4ef');eml.set('postbox', '1f4ee');eml.set('potable_water', '1f6b0');eml.set('pouch', '1f45d');eml.set('poultry_leg', '1f357');eml.set('pound', '1f4b7');eml.set('pouting_cat', '1f63e');eml.set('pray', '1f64f');eml.set('princess', '1f478');eml.set('purple_heart', '1f49c');eml.set('purse', '1f45b');eml.set('pushpin', '1f4cc');eml.set('put_litter_in_its_place', '1f6ae');eml.set('question', '2753');eml.set('rabbit', '1f430');eml.set('rabbit2', '1f407');eml.set('racehorse', '1f40e');eml.set('radio', '1f4fb');eml.set('radio_button', '1f518');eml.set('rage', '1f621');eml.set('railway_car', '1f683');eml.set('rainbow', '1f308');eml.set('raised_hands', '1f64c');eml.set('raising_hand', '1f64b');eml.set('ram', '1f40f');eml.set('ramen', '1f35c');eml.set('rat', '1f400');eml.set('recycle', '267b');eml.set('red_circle', '1f534');eml.set('registered', '00ae');eml.set('relaxed', '263a');eml.set('relieved', '1f60c');eml.set('repeat', '1f501');eml.set('repeat_one', '1f502');eml.set('restroom', '1f6bb');eml.set('revolving_hearts', '1f49e');eml.set('rewind', '23ea');eml.set('ribbon', '1f380');eml.set('rice', '1f35a');eml.set('rice_ball', '1f359');eml.set('rice_cracker', '1f358');eml.set('rice_scene', '1f391');eml.set('ring', '1f48d');eml.set('rocket', '1f680');eml.set('roller_coaster', '1f3a2');eml.set('rooster', '1f413');eml.set('rose', '1f339');eml.set('rotating_light', '1f6a8');eml.set('round_pushpin', '1f4cd');eml.set('rowboat', '1f6a3');eml.set('ru', '1f1f7-1f1fa');eml.set('rugby_football', '1f3c9');eml.set('runner', '1f3c3');eml.set('running', '1f3c3');eml.set('running_shirt_with_sash', '1f3bd');eml.set('sa', '1f202');eml.set('sagittarius', '2650');eml.set('sake', '1f376');eml.set('sandal', '1f461');eml.set('santa', '1f385');eml.set('satellite', '1f4e1');eml.set('saxophone', '1f3b7');eml.set('school_satchel', '1f392');eml.set('scissors', '2702');eml.set('scorpius', '264f');eml.set('scream', '1f631');eml.set('scream_cat', '1f640');eml.set('scroll', '1f4dc');eml.set('seat', '1f4ba');eml.set('secret', '3299');eml.set('see_no_evil', '1f648');eml.set('seedling', '1f331');eml.set('seven', '0037-20e3');eml.set('shaved_ice', '1f367');eml.set('sheep', '1f411');eml.set('shell', '1f41a');eml.set('ship', '1f6a2');eml.set('shirt', '1f455');eml.set('tshirt', '1f455');eml.set('shower', '1f6bf');eml.set('signal_strength', '1f4f6');eml.set('six', '0036-20e3');eml.set('six_pointed_star', '1f52f');eml.set('ski', '1f3bf');eml.set('skull', '1f480');eml.set('sleeping', '1f634');eml.set('sleepy', '1f62a');eml.set('slot_machine', '1f3b0');eml.set('small_blue_diamond', '1f539');eml.set('small_orange_diamond', '1f538');eml.set('small_red_triangle', '1f53a');eml.set('small_red_triangle_down', '1f53b');eml.set('smile_cat', '1f638');eml.set('smiley', '1f603');eml.set('smiley_cat', '1f63a');eml.set('smiling_imp', '1f608');eml.set('smirk', '1f60f');eml.set('smirk_cat', '1f63c');eml.set('smoking', '1f6ac');eml.set('snail', '1f40c');eml.set('snake', '1f40d');eml.set('snowboarder', '1f3c2');eml.set('snowflake', '2744');eml.set('snowman', '26c4');eml.set('sob', '1f62d');eml.set('soccer', '26bd');eml.set('soon', '1f51c');eml.set('sos', '1f198');eml.set('sound', '1f509');eml.set('space_invader', '1f47e');eml.set('spades', '2660');eml.set('spaghetti', '1f35d');eml.set('sparkler', '1f387');eml.set('sparkles', '2728');eml.set('sparkling_heart', '1f496');eml.set('speak_no_evil', '1f64a');eml.set('speaker', '1f508');eml.set('speech_balloon', '1f4ac');eml.set('speedboat', '1f6a4');eml.set('star', '2b50');eml.set('star2', '1f31f');eml.set('stars', '1f320');eml.set('station', '1f689');eml.set('statue_of_liberty', '1f5fd');eml.set('steam_locomotive', '1f682');eml.set('stew', '1f372');eml.set('straight_ruler', '1f4cf');eml.set('strawberry', '1f353');eml.set('stuck_out_tongue', '1f61b');eml.set('stuck_out_tongue_closed_eyes', '1f61d');eml.set('stuck_out_tongue_winking_eye', '1f61c');eml.set('sun_with_face', '1f31e');eml.set('sunflower', '1f33b');eml.set('sunglasses', '1f60e');eml.set('sunrise', '1f305');eml.set('sunrise_over_mountains', '1f304');eml.set('surfer', '1f3c4');eml.set('sushi', '1f363');eml.set('suspension_railway', '1f69f');eml.set('sweat', '1f613');eml.set('sweat_drops', '1f4a6');eml.set('sweat_smile', '1f605');eml.set('sweet_potato', '1f360');eml.set('swimmer', '1f3ca');eml.set('symbols', '1f523');eml.set('syringe', '1f489');eml.set('tada', '1f389');eml.set('tanabata_tree', '1f38b');eml.set('tangerine', '1f34a');eml.set('taurus', '2649');eml.set('taxi', '1f695');eml.set('tea', '1f375');eml.set('telephone_receiver', '1f4de');eml.set('telescope', '1f52d');eml.set('tennis', '1f3be');eml.set('tent', '26fa');eml.set('thought_balloon', '1f4ad');eml.set('ticket', '1f3ab');eml.set('tiger', '1f42f');eml.set('tiger2', '1f405');eml.set('information_desk_person', '1f481');eml.set('tired_face', '1f62b');eml.set('tm', '2122');eml.set('toilet', '1f6bd');eml.set('tokyo_tower', '1f5fc');eml.set('tomato', '1f345');eml.set('tongue', '1f445');eml.set('top', '1f51d');eml.set('tophat', '1f3a9');eml.set('tractor', '1f69c');eml.set('traffic_light', '1f6a5');eml.set('train', '1f68b');eml.set('train2', '1f686');eml.set('tram', '1f68a');eml.set('triangular_flag_on_post', '1f6a9');eml.set('triangular_ruler', '1f4d0');eml.set('trident', '1f531');eml.set('triumph', '1f624');eml.set('trolleybus', '1f68e');eml.set('trophy', '1f3c6');eml.set('tropical_drink', '1f379');eml.set('tropical_fish', '1f420');eml.set('truck', '1f69a');eml.set('trumpet', '1f3ba');eml.set('tulip', '1f337');eml.set('turtle', '1f422');eml.set('tv', '1f4fa');eml.set('twisted_rightwards_arrows', '1f500');eml.set('two_hearts', '1f495');eml.set('two_men_holding_hands', '1f46c');eml.set('two_women_holding_hands', '1f46d');eml.set('u5272', '1f239');eml.set('u5408', '1f234');eml.set('u55b6', '1f23a');eml.set('u6307', '1f22f');eml.set('u6708', '1f237');eml.set('u6709', '1f236');eml.set('u6e80', '1f235');eml.set('u7121', '1f21a');eml.set('u7533', '1f238');eml.set('u7981', '1f232');eml.set('u7a7a', '1f233');eml.set('unamused', '1f612');eml.set('underage', '1f51e');eml.set('unlock', '1f513');eml.set('up', '1f199');eml.set('us', '1f1fa-1f1f8');eml.set('v', '270c');eml.set('vertical_traffic_light', '1f6a6');eml.set('vhs', '1f4fc');eml.set('vibration_mode', '1f4f3');eml.set('video_camera', '1f4f9');eml.set('video_game', '1f3ae');eml.set('violin', '1f3bb');eml.set('virgo', '264d');eml.set('volcano', '1f30b');eml.set('vs', '1f19a');eml.set('walking', '1f6b6');eml.set('waning_crescent_moon', '1f318');eml.set('waning_gibbous_moon', '1f316');eml.set('warning', '26a0');eml.set('watch', '231a');eml.set('water_buffalo', '1f403');eml.set('watermelon', '1f349');eml.set('wave', '1f44b');eml.set('wavy_dash', '3030');eml.set('waxing_crescent_moon', '1f312');eml.set('wc', '1f6be');eml.set('weary', '1f629');eml.set('wedding', '1f492');eml.set('whale', '1f433');eml.set('whale2', '1f40b');eml.set('wheelchair', '267f');eml.set('white_check_mark', '2705');eml.set('white_circle', '26aa');eml.set('white_flower', '1f4ae');eml.set('white_square_button', '1f533');eml.set('wind_chime', '1f390');eml.set('wine_glass', '1f377');eml.set('wink', '1f609');eml.set('wolf', '1f43a');eml.set('woman', '1f469');eml.set('dancer', '1f483');eml.set('bride_with_veil', '1f470-2640');eml.set('womans_clothes', '1f45a');eml.set('womans_hat', '1f452');eml.set('womens', '1f6ba');eml.set('worried', '1f61f');eml.set('wrench', '1f527');eml.set('x', '274c');eml.set('yellow_heart', '1f49b');eml.set('yen', '1f4b4');eml.set('yum', '1f60b');eml.set('zap', '26a1');eml.set('zero', '0030-20e3');eml.set('zzz', '1f4a4');eml.set('bamboo', '1f38d');eml.set('cloud', '2601');eml.set('dolls', '1f38e');eml.set('gift_heart', '1f49d');eml.set('house', '1f3e0');eml.set('house_with_garden', '1f3e1');eml.set('laughing', '1f606');eml.set('one', '0031-20e3');eml.set('school', '1f3eb');eml.set('smile', '1f604');eml.set('sunny', '2600');eml.set('three', '0033-20e3');eml.set('two', '0032-20e3');eml.set('umbrella', '2614');

var fnID = 1;
var footnoteFull = "";
var footnoteHTML = [];
var footnoteStart = [];
var footnoteHead = '\n<hr class="footnotes-sep">\n<section class="footnotes">\n<ol class="footnotes-list">\n';
var footnoteFoot = '</ol>\n</section>\n';
var findFootnote = false;
var definitionStart = false;

;(function(root) {
	'use strict';

/**
* Block-Level Grammar
*/

	var block = {
		newline: /^\n+/,
		code: /^( {4}[^\n]+\n*)+/,
		fences: noop,
		emoji: noop,
		footnote: noop,
		definition:/^([^:\n]+)(?:[\n]+)(?:\:+)(?:\s+)([^\n]+)(?:\n+|$)/,
		definitionLine:/^(?:\:+)(?:\s+)([^\n]+)(?:\n+|$)/,//(^:[^\n]+)(?:\n+|$))/,
		footnotelink: /^((\[\^[^\]]+\]\: )([^\n]+)(?:\n+|$))/,
		hr: /^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,
		heading: /^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,
		nptable: noop,
		blockquote: /^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,
		list: /^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,
		html: '^ {0,3}(?:' // optional indentation
		+ '<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)' // (1)
		+ '|comment[^\\n]*(\\n+|$)' // (2)
		+ '|<\\?[\\s\\S]*?\\?>\\n*' // (3)
		+ '|<![A-Z][\\s\\S]*?>\\n*' // (4)
		+ '|<!\\[CDATA\\[[\\s\\S]*?\\]\\]>\\n*' // (5)
		+ '|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)' // (6)
		+ '|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=\\h*\\n)[\\s\\S]*?(?:\\n{2,}|$)' // (7) open tag
		+ '|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=\\h*\\n)[\\s\\S]*?(?:\\n{2,}|$)' // (7) closing tag
		+ ')',
		def: /^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,
		table: noop,
		lheading: /^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,
		paragraph: /^([^\n]+(?:\n(?!hr|heading|lheading| {0,3}>|<\/?(?:tag)(?: +|\n|\/?>)|<(?:script|pre|style|!--))[^\n]+)*)/,
		text: /^[^\n]+/
	};

	block._label = /(?!\s*\])(?:\\[\[\]]|[^\[\]])+/;
	block._title = /(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/;
	block.def = edit(block.def)
	.replace('label', block._label)
	.replace('title', block._title)
	.getRegex();

	block.bullet = /(?:[*+-]|\d{1,9}\.)/;
	block.item = /^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/;
	block.item = edit(block.item, 'gm')
	.replace(/bull/g, block.bullet)
	.getRegex();

	block.list = edit(block.list)
	.replace(/bull/g, block.bullet)
	.replace('hr', '\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))')
	.replace('def', '\\n+(?=' + block.def.source + ')')
	.getRegex();

	block._tag = 'address|article|aside|base|basefont|blockquote|body|caption'
	+ '|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption'
	+ '|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe'
	+ '|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option'
	+ '|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr'
	+ '|track|ul';
	block._comment = /<!--(?!-?>)[\s\S]*?-->/;
	block.html = edit(block.html, 'i')
	.replace('comment', block._comment)
	.replace('tag', block._tag)
	.replace('attribute', / +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/)
	.getRegex();

	block.paragraph = edit(block.paragraph)
	.replace('hr', block.hr)
	.replace('heading', block.heading)
	.replace('lheading', block.lheading)
	.replace('tag', block._tag) // pars can be interrupted by type (6) html blocks
	.getRegex();

	block.blockquote = edit(block.blockquote)
	.replace('paragraph', block.paragraph)
	.getRegex();

/**
* Normal Block Grammar
*/

	block.normal = merge({}, block);

/**
* GFM Block Grammar
*/

	block.gfm = merge({}, block.normal, {
		fences: /^ {0,3}(`{3,}|~{3,})([^`\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,
		paragraph: /^/,
		heading: /^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/
	});

	block.gfm.paragraph = edit(block.paragraph)
	.replace('(?!', '(?!'
	+ block.gfm.fences.source.replace('\\1', '\\2') + '|'
	+ block.list.source.replace('\\1', '\\3') + '|')
	.getRegex();

/**
* GFM + Tables Block Grammar
*/

	block.tables = merge({}, block.gfm, {
		nptable: /^ *([^|\n ].*\|.*)\n *([-:]+ *\|[-| :]*)(?:\n((?:.*[^>\n ].*(?:\n|$))*)\n*|$)/,
		table: /^ *\|(.+)\n *\|?( *[-:]+[-| :]*)(?:\n((?: *[^>\n ].*(?:\n|$))*)\n*|$)/
	});

/**
* Pedantic grammar
*/

	block.pedantic = merge({}, block.normal, {
		html: edit(
		'^ *(?:comment *(?:\\n|\\s*$)'
		+ '|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)' // closed tag
		+ '|<tag(?:"[^"]*"|\'[^\']*\'|\\s[^\'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))')
		.replace('comment', block._comment)
		.replace(/tag/g, '(?!(?:'
		+ 'a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub'
		+ '|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)'
		+ '\\b)\\w+(?!:|[^\\w\\s@]*@)\\b')
		.getRegex(),
		def: /^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/
	});

/**
* Block Lexer
*/

	function Lexer(options)
	{
		this.tokens = [];
		this.tokens.links = Object.create(null);
		this.options = options || marked.defaults;
		this.rules = block.normal;

		if (this.options.pedantic) {
			this.rules = block.pedantic;
		} else if (this.options.gfm) {
			if (this.options.tables) {
				this.rules = block.tables;
			} else {
				this.rules = block.gfm;
			}
		}
	}

/**
* Expose Block Rules
*/

	Lexer.rules = block;

/**
* Static Lex Method
*/

	Lexer.lex = function(src, options) {
		var lexer = new Lexer(options);
		return lexer.lex(src);
	};

/**
* Preprocessing
*/

	Lexer.prototype.lex = function(src) {
		src = src
		.replace(/\r\n|\r/g, '\n')
		.replace(/\t/g, '    ')
		.replace(/\u00a0/g, ' ')
		.replace(/\u2424/g, '\n');

		return this.token(src, true);
	};

/**
* Lexing
*/

	Lexer.prototype.token = function(src, top) {
		src = src.replace(/^ +$/gm, '');
		var next,
		loose,
		cap,
		bull,
		b,
		item,
		listStart,
		listItems,
		t,
		space,
		i,
		tag,
		l,
		isordered,
		istask,
		ischecked;
		while (src) {
			// newline
			if (cap = this.rules.newline.exec(src)) {
				src = src.substring(cap[0].length);
				if (cap[0].length > 1) {
					this.tokens.push({
						type: 'space'
					});
				}
			}
			// footnotelink
			findFootnote = false;
			if (cap = this.rules.footnotelink.exec(src)) {
				src = "    " + src.substring(cap[2].length);
				findFootnote = true;
				var name = /^\[\^([^\s\]]+)\]:/.exec(cap[2]);
				footnoteStart.push('<p><li id="fn:' + name[1] + '"  class="footnote-item">');
				footnoteHTML.push('<a href="#fnref:' + name[1] + '" class="footnote-backref">&#x21A9;</a></li>');
			}
					

			// code
			if (cap = this.rules.code.exec(src)) {

				src = src.substring(cap[0].length);
				if (!findFootnote) {
					cap = cap[0].replace(/^ {4}/gm, '');
				}else{
					cap = cap[0];
				}

				if (findFootnote) {
					this.tokens.push({
						type: 'footnotelink',
						text: !this.options.pedantic ? rtrim(cap, '\n') : cap
					});
				} else {
					this.tokens.push({
						type: 'code',
						text: !this.options.pedantic ? rtrim(cap, '\n') : cap
					});
				}
				findFootnote = false;
				continue;
			}
			
			//definition
			if (cap = this.rules.definition.exec(src)) {
				src = src.substring(cap[0].length).trim();
				var term = cap[1];
				var definition = [cap[2]];
				for (;;) {
					cap = this.rules.definitionLine.exec(src);
					if (!cap)
						break;
					src = src.substring(cap[0].length).trim();	
					definition.push(cap[1]);
				}
				this.tokens.push({
					type: 'definition',
					term: term,
					definition: definition
				});
				continue;
			}
				
			// fences (gfm)
			if (cap = this.rules.fences.exec(src)) {
				src = src.substring(cap[0].length);
				this.tokens.push({
					type: 'code',
					lang: cap[2] ? cap[2].trim() : cap[2],
					text: cap[3] || ''
				});
				continue;
			}

			// heading
			if (cap = this.rules.heading.exec(src)) {
				src = src.substring(cap[0].length);
				this.tokens.push({
					type: 'heading',
					depth: cap[1].length,
					text: cap[2]
				});
				continue;
			}

			// table no leading pipe (gfm)
			if (top && (cap = this.rules.nptable.exec(src))) {
				item = {
					type: 'table',
					header: splitCells(cap[1].replace(/^ *| *\| *$/g, '')),
					align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
					cells: cap[3] ? cap[3].replace(/\n$/, '').split('\n') : []
				};

				if (item.header.length === item.align.length) {
					src = src.substring(cap[0].length);

					for (i = 0; i < item.align.length; i++) {
						if (/^ *-+: *$/.test(item.align[i])) {
							item.align[i] = 'right';
						} else if (/^ *:-+: *$/.test(item.align[i])) {
							item.align[i] = 'center';
						} else if (/^ *:-+ *$/.test(item.align[i])) {
							item.align[i] = 'left';
						} else {
							item.align[i] = null;
						}
					}

					for (i = 0; i < item.cells.length; i++) {
						item.cells[i] = splitCells(item.cells[i], item.header.length);
					}

					this.tokens.push(item);

					continue;
				}
			}

			// hr
			if (cap = this.rules.hr.exec(src)) {
				src = src.substring(cap[0].length);
				this.tokens.push({
					type: 'hr'
				});
				continue;
			}

			// blockquote
			if (cap = this.rules.blockquote.exec(src)) {
				src = src.substring(cap[0].length);

				this.tokens.push({
					type: 'blockquote_start'
				});
				cap = cap[0].replace(/^ *> ?/gm, '');


				// Pass `top` to keep the current
				// "toplevel" state. This is exactly
				// how markdown.pl works.
				this.token(cap, top);
				this.tokens.push({
					type: 'blockquote_end'
				});

				continue;
			}

			// list
			if (cap = this.rules.list.exec(src)) {
				src = src.substring(cap[0].length);
				bull = cap[2];
				isordered = bull.length > 1;

				listStart = {
					type: 'list_start',
					ordered: isordered,
					start: isordered ? +bull : '',
					loose: false
				};

				this.tokens.push(listStart);

				// Get each top-level item.
				cap = cap[0].match(this.rules.item);

				listItems = [];
				next = false;
				l = cap.length;
				i = 0;

				for (; i < l; i++) {
					item = cap[i];

					// Remove the list item's bullet
					// so it is seen as the next token.
					space = item.length;
					item = item.replace(/^ *([*+-]|\d+\.) */, '');

					// Outdent whatever the
					// list item contains. Hacky.
					if (~item.indexOf('\n ')) {
						space -= item.length;
						item = !this.options.pedantic
						? item.replace(new RegExp('^ {1,' + space + '}', 'gm'), '')
						: item.replace(/^ {1,4}/gm, '');
					}

					// Determine whether the next list item belongs here.
					// Backpedal if it does not belong in this list.
					if (i !== l - 1) {
						b = block.bullet.exec(cap[i + 1])[0];
						if (bull.length > 1 ? b.length === 1
						: (b.length > 1 || (this.options.smartLists && b !== bull))) {
							src = cap.slice(i + 1).join('\n') + src;
							i = l - 1;
						}
					}

					// Determine whether item is loose or not.
					// Use: /(^|\n)(?! )[^\n]+\n\n(?!\s*$)/
					// for discount behavior.
					loose = next || /\n\n(?!\s*$)/.test(item);
					if (i !== l - 1) {
						next = item.charAt(item.length - 1) === '\n';
						if (!loose)
							loose = next;
					}

					if (loose) {
						listStart.loose = true;
					}

					// Check for task list items
					istask = /^\[[ xX]\] /.test(item);
					ischecked = undefined;
					if (istask) {
						ischecked = item[1] !== ' ';
						item = item.replace(/^\[[ xX]\] +/, '');
					}

					t = {
						type: 'list_item_start',
						task: istask,
						checked: ischecked,
						loose: loose
					};

					listItems.push(t);
					this.tokens.push(t);

					// Recurse.
					this.token(item, false);

					this.tokens.push({
						type: 'list_item_end'
					});
				}

				if (listStart.loose) {
					l = listItems.length;
					i = 0;
					for (; i < l; i++) {
						listItems[i].loose = true;
					}
				}

				this.tokens.push({
					type: 'list_end'
				});

				continue;
			}

			// html
			if (cap = this.rules.html.exec(src)) {
				src = src.substring(cap[0].length);
				this.tokens.push({
					type: this.options.sanitize
					? 'paragraph'
					: 'html',
					pre: !this.options.sanitizer
					&& (cap[1] === 'pre' || cap[1] === 'script' || cap[1] === 'style'),
					text: cap[0]
				});
				continue;
			}

			// def
			if (top && (cap = this.rules.def.exec(src))) {
				src = src.substring(cap[0].length);
				if (cap[3])
					cap[3] = cap[3].substring(1, cap[3].length - 1);
				tag = cap[1].toLowerCase().replace(/\s+/g, ' ');
				if (!this.tokens.links[tag]) {
					this.tokens.links[tag] = {
						href: cap[2],
						title: cap[3]
					};
				}
				continue;
			}

			// table (gfm)
			if (top && (cap = this.rules.table.exec(src))) {
				item = {
					type: 'table',
					header: splitCells(cap[1].replace(/^ *| *\| *$/g, '')),
					align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
					cells: cap[3] ? cap[3].replace(/(?: *\| *)?\n$/, '').split('\n') : []
				};

				if (item.header.length === item.align.length) {
					src = src.substring(cap[0].length);

					for (i = 0; i < item.align.length; i++) {
						if (/^ *-+: *$/.test(item.align[i])) {
							item.align[i] = 'right';
						} else if (/^ *:-+: *$/.test(item.align[i])) {
							item.align[i] = 'center';
						} else if (/^ *:-+ *$/.test(item.align[i])) {
							item.align[i] = 'left';
						} else {
							item.align[i] = null;
						}
					}

					for (i = 0; i < item.cells.length; i++) {
						item.cells[i] = splitCells(
						item.cells[i].replace(/^ *\| *| *\| *$/g, ''),
						item.header.length);
					}

					this.tokens.push(item);

					continue;
				}
			}

			// lheading
			if (cap = this.rules.lheading.exec(src)) {
				src = src.substring(cap[0].length);
				this.tokens.push({
					type: 'heading',
					depth: cap[2] === '=' ? 1 : 2,
					text: cap[1]
				});
				continue;
			}

			// top-level paragraph
			if (top && (cap = this.rules.paragraph.exec(src))) {
				src = src.substring(cap[0].length);
				this.tokens.push({
					type: 'paragraph',
					text: cap[1].charAt(cap[1].length - 1) === '\n'
					? cap[1].slice(0, -1)
					: cap[1]
				});
				continue;
			}

			// text
			if (cap = this.rules.text.exec(src)) {
				// Top-level should never reach here.
				src = src.substring(cap[0].length);
				this.tokens.push({
					type: 'text',
					text: cap[0]
				});
				continue;
			}

			if (src) {
				throw new Error('Infinite loop on byte: ' + src.charCodeAt(0));
			}
		}

		return this.tokens;
	};

/**
* Inline-Level Grammar
*/

	var inline = {
		escape: /^\\([!"#$%&'()*+,\-.\/:;<=>?@\[\]\\^_`{|}~])/,
  autolink: /^<(scheme:[^\s\x00-\x1f<>]*|email)>/,
  url: noop,
  tag: '^comment'
    + '|^</[a-zA-Z][\\w:-]*\\s*>' 
    + '|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>' 
    + '|^<\\?[\\s\\S]*?\\?>' 
    + '|^<![a-zA-Z]+\\s[\\s\\S]*?>'
    + '|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>',
  link: /^!?\[(label)\]\(href(?:\s+(title))?\s*\)/,
  reflink: /^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,
  nolink: /^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,
  strong: /^__([^\s_])__(?!_)|^\*\*([^\s*])\*\*(?!\*)|^__([^\s][\s\S]*?[^\s])__(?!_)|^\*\*([^\s][\s\S]*?[^\s])\*\*(?!\*)/,
  em: /^_([^\s_])_(?!_)|^\*([^\s*"<\[])\*(?!\*)|^_([^\s][\s\S]*?[^\s_])_(?!_|[^\spunctuation])|^_([^\s_][\s\S]*?[^\s])_(?!_|[^\spunctuation])|^\*([^\s"<\[][\s\S]*?[^\s*])\*(?!\*)|^\*([^\s*"<\[][\s\S]*?[^\s])\*(?!\*)/,
  emoji: /^:([^\s][^:]+):/,
  footnotelink: /^\[\^([^\s\]]+)\]:/,
  footnote: /^\[\^([^\s\]]+)\]/,
  code: /^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,
			br: /^( {2,}|\\)\n(?!\s*$)/,
			del: noop,
			text: /^(`+|[^`])[\s\S]*?(?=[\\<!\[`*:]|\b_| {2,}\n|$)/
		};

		// list of punctuation marks from common mark spec
		// without ` and ] to workaround Rule 17 (inline code blocks/links)
		inline._punctuation = '!"#$%&\'()*+,\\-./:;<=>?@\\[^_{|}~';
		inline.em = edit(inline.em).replace(/punctuation/g, inline._punctuation).getRegex();

		inline._escapes = /\\([!"#$%&'()*+,\-.\/:;<=>?@\[\]\\^_`{|}~])/g;

inline._scheme = /[a-zA-Z][a-zA-Z0-9+.-]{1,31}/;
inline._email = /[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/;
	inline.autolink = edit(inline.autolink)
	.replace('scheme', inline._scheme)
	.replace('email', inline._email)
	.getRegex();

	inline._attribute = /\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/;

	inline.tag = edit(inline.tag)
	.replace('comment', block._comment)
	.replace('attribute', inline._attribute)
	.getRegex();

	inline._label = /(?:\[[^\[\]]*\]|\\[\[\]]?|`[^`]*`|[^\[\]\\])*?/;
	inline._href = /\s*(<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*)/;
	inline._title = /"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/;

	inline.link = edit(inline.link)
	.replace('label', inline._label)
	.replace('href', inline._href)
	.replace('title', inline._title)
	.getRegex();

	inline.reflink = edit(inline.reflink)
	.replace('label', inline._label)
	.getRegex();

/**
* Normal Inline Grammar
*/

	inline.normal = merge({}, inline);

/**
* Pedantic Inline Grammar
*/

	inline.pedantic = merge({}, inline.normal, {
		strong: /^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,
		em: /^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/,
		link: edit(/^!?\[(label)\]\((.*?)\)/)
		.replace('label', inline._label)
		.getRegex(),
		reflink: edit(/^!?\[(label)\]\s*\[([^\]]*)\]/)
		.replace('label', inline._label)
		.getRegex()
	});

/**
* GFM Inline Grammar
*/

	inline.gfm = merge({}, inline.normal, {
		escape: edit(inline.escape).replace('])', '~|])').getRegex(),
		_extended_email: /[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,
		url: /^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,
		_backpedal: /(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,
		del: /^~+(?=\S)([\s\S]*?\S)~+/,
		text: edit(inline.text)
		.replace(']|', '~]|')
		.replace('|$', '|https?://|ftp://|www\\.|[a-zA-Z0-9.!#$%&\'*+/=?^_`{\\|}~-]+@|$')
		.getRegex()
	});

	inline.gfm.url = edit(inline.gfm.url, 'i')
	.replace('email', inline.gfm._extended_email)
	.getRegex();
/**
* GFM + Line Breaks Inline Grammar
*/

	inline.breaks = merge({}, inline.gfm, {
		br: edit(inline.br).replace('{2,}', '*').getRegex(),
		text: edit(inline.gfm.text).replace('{2,}', '*').getRegex()
	});

/**
* Inline Lexer & Compiler
*/

	function InlineLexer(links, options)
	{
		this.options = options || marked.defaults;
		this.links = links;
		this.rules = inline.normal;
		this.renderer = this.options.renderer || new Renderer();
		this.renderer.options = this.options;

		if (!this.links) {
			throw new Error('Tokens array requires a `links` property.');
		}

		if (this.options.pedantic) {
			this.rules = inline.pedantic;
		} else if (this.options.gfm) {
			if (this.options.breaks) {
				this.rules = inline.breaks;
			} else {
				this.rules = inline.gfm;
			}
		}
	}

/**
* Expose Inline Rules
*/

	InlineLexer.rules = inline;

/**
* Static Lexing/Compiling Method
*/

	InlineLexer.output = function(src, links, options) {
		var inline = new InlineLexer(links, options);
		return inline.output(src);
	};

/**
* Lexing/Compiling
*/

	InlineLexer.prototype.output = function(src) {
		var out = '',
		link,
		text,
		href,
		title,
		cap,
		prevCapZero;

		while (src) {
			// escape
			if (cap = this.rules.escape.exec(src)) {
				src = src.substring(cap[0].length);
				out += escape(cap[1]);
				continue;
			}

			// footnote
			if (cap = this.rules.footnote.exec(src)) {
				src = src.substring(cap[0].length);
				var txt = cap[1];
				out += this.renderer.footnote(txt);
				continue;
			}
			// tag
			if (cap = this.rules.tag.exec(src)) {
				if (!this.inLink && /^<a /i.test(cap[0])) {
					this.inLink = true;
				} else if (this.inLink && /^<\/a>/i.test(cap[0])) {
					this.inLink = false;
				}
				if (!this.inRawBlock && /^<(pre|code|kbd|script)(\s|>)/i.test(cap[0])) {
					this.inRawBlock = true;
				} else if (this.inRawBlock && /^<\/(pre|code|kbd|script)(\s|>)/i.test(cap[0])) {
					this.inRawBlock = false;
				}

				src = src.substring(cap[0].length);
				out += this.options.sanitize
				? this.options.sanitizer
				? this.options.sanitizer(cap[0])
				: escape(cap[0])
				: cap[0];
				continue;
			}

			// link
			if (cap = this.rules.link.exec(src)) {
				var lastParenIndex = findClosingBracket(cap[2], '()');
				if (lastParenIndex > -1) {
					var removeChars = cap[2].length - lastParenIndex;
					cap[2] = cap[2].substring(0, lastParenIndex);
					cap[0] = cap[0].substring(0, cap[0].length - removeChars);
				}
				src = src.substring(cap[0].length);
				this.inLink = true;
				href = cap[2];
				if (this.options.pedantic) {
					link = /^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(href);

					if (link) {
						href = link[1];
						title = link[3];
					} else {
						title = '';
					}
				} else {
					title = cap[3] ? cap[3].slice(1, -1) : '';
				}
				href = href.trim().replace(/^<([\s\S]*)>$/, '$1');
				out += this.outputLink(cap, {
					href: InlineLexer.escapes(href),
					title: InlineLexer.escapes(title)
				});
				this.inLink = false;
				continue;
			}

			// reflink, nolink
			if ((cap = this.rules.reflink.exec(src))
			|| (cap = this.rules.nolink.exec(src))) {
				src = src.substring(cap[0].length);
				link = (cap[2] || cap[1]).replace(/\s+/g, ' ');
				link = this.links[link.toLowerCase()];
				if (!link || !link.href) {
					out += cap[0].charAt(0);
					src = cap[0].substring(1) + src;
					continue;
				}
				this.inLink = true;
				out += this.outputLink(cap, link);
				this.inLink = false;
				continue;
			}

			// strong
			if (cap = this.rules.strong.exec(src)) {
				src = src.substring(cap[0].length);
				out += this.renderer.strong(this.output(cap[4] || cap[3] || cap[2] || cap[1]));
				continue;
			}

			// em
			if (cap = this.rules.em.exec(src)) {
				src = src.substring(cap[0].length);
				out += this.renderer.em(this.output(cap[6] || cap[5] || cap[4] || cap[3] || cap[2] || cap[1]));
				continue;
			}

			// code
			if (cap = this.rules.code.exec(src)) {
				src = src.substring(cap[0].length);
				out += this.renderer.codespan(escape(cap[2].trim(), true));
				continue;
			}

			// emoji
			if (cap = this.rules.emoji.exec(src)) {
				src = src.substring(cap[0].length);
				if (eml.has(cap[1])) {
					var charcode = eml.get(cap[1]);
					out += this.renderer.emoji(charcode);
				} else {
					out += cap[0];
				}
				continue;
			}

			// br
			if (cap = this.rules.br.exec(src)) {
				src = src.substring(cap[0].length);
				out += this.renderer.br();
				continue;
			}

			// del (gfm)
			if (cap = this.rules.del.exec(src)) {
				src = src.substring(cap[0].length);
				out += this.renderer.del(this.output(cap[1]));
				continue;
			}

			// autolink
			if (cap = this.rules.autolink.exec(src)) {
				src = src.substring(cap[0].length);
				if (cap[2] === '@') {
					text = escape(this.mangle(cap[1]));
					href = 'mailto:' + text;
				} else {
					text = escape(cap[1]);
					href = text;
				}
				out += this.renderer.link(href, null, text);
				continue;
			}

			// url (gfm)
			if (!this.inLink && (cap = this.rules.url.exec(src))) {
				if (cap[2] === '@') {
					text = escape(cap[0]);
					href = 'mailto:' + text;
				} else {
					// do extended autolink path validation
					do {
						prevCapZero = cap[0];
						cap[0] = this.rules._backpedal.exec(cap[0])[0];
					} while (prevCapZero !== cap[0]);
					text = escape(cap[0]);
					if (cap[1] === 'www.') {
						href = 'http://' + text;
					} else {
						href = text;
					}
				}
				src = src.substring(cap[0].length);
				out += this.renderer.link(href, null, text);
				continue;
			}

			// text
			if (cap = this.rules.text.exec(src)) {
				src = src.substring(cap[0].length);
				if (this.inRawBlock) {
					out += this.renderer.text(cap[0]);
				} else {
					out += this.renderer.text(escape(this.smartypants(cap[0])));
				}
				continue;
			}

			if (src) {
				throw new Error('Infinite loop on byte: ' + src.charCodeAt(0));
			}
		}

		return out;
	};

	InlineLexer.escapes = function(text) {
		return text ? text.replace(InlineLexer.rules._escapes, '$1') : text;
	};

/**
* Compile Link
*/

	InlineLexer.prototype.outputLink = function(cap, link) {
		var href = link.href,
		title = link.title ? escape(link.title) : null;

		return cap[0].charAt(0) !== '!'
		? this.renderer.link(href, title, this.output(cap[1]))
		: this.renderer.image(href, title, escape(cap[1]));
	};

/**
* Smartypants Transformations
*/

	InlineLexer.prototype.smartypants = function(text) {
		if (!this.options.smartypants)
			return text;
		return text
		// em-dashes
		.replace(/---/g, '\u2014')
		// en-dashes
		.replace(/--/g, '\u2013')
		// opening singles
		.replace(/(^|[-\u2014/(\[{"\s])'/g, '$1\u2018')
    // closing singles & apostrophes
    .replace(/'/g, '\u2019')
    // opening doubles
    .replace(/(^|[-\u2014/(\[{\u2018\s])"/g, '$1\u201c')
				// closing doubles
				.replace(/"/g, '\u201d')
				// ellipses
				.replace(/\.{3}/g, '\u2026');
			};

/**
* Mangle Links
*/

			InlineLexer.prototype.mangle = function(text) {
				if (!this.options.mangle)
					return text;
				var out = '',
				l = text.length,
				i = 0,
				ch;

				for (; i < l; i++) {
					ch = text.charCodeAt(i);
					if (Math.random() > 0.5) {
						ch = 'x' + ch.toString(16);
					}
					out += '&#' + ch + ';';
				}

				return out;
			};

/**
* Renderer
*/

			function Renderer(options)
			{
				this.options = options || marked.defaults;
			}

			Renderer.prototype.code = function(code, infostring, escaped) {
				var lang = (infostring || '').match(/\S*/)[0];
				if (this.options.highlight) {
					var out = this.options.highlight(code, lang);
					if (out != null && out !== code) {
						escaped = true;
						code = out;
					}
				}

				if (!lang) {
					return '<pre><code>'
					+ code//(escaped ? code : escape(code, true))
					+ '</code></pre>';
				}

				return '<pre><code class="'
				+ this.options.langPrefix
				+ escape(lang, true)
				+ '">'
				+ (escaped ? code : escape(code, true))
				+ '</code></pre>\n';
			};

			Renderer.prototype.footnotelink = function(code, infostring, escaped) {
				code = code.replace(/^ {4}/gm, '<p>');

				code = footnoteStart[0] + code;
				while (code.indexOf("\n\n") != -1)
					code = code.replace(/\n\n/gm, '\n');
				code = code.replace(/\n/gm, '</p>\n');
				if (code.substring(code.length - 5) != '</p>\n')
					code += footnoteHTML[0] + '</p>\n';
				else {
					var position = cap.length - 5;
					code = [code.slice(0, position), footnoteHTML[0], code.slice(position)].join('');
				}
				footnoteStart.shift();
				footnoteHTML.shift();
				if (footnoteFull == "")
					footnoteFull = footnoteHead;
				footnoteFull += code;
				return "";
			};

			Renderer.prototype.definition = function(term, definition) {
				let txt = "<dl>\n<dt>" + term + "</dt>\n";  
				for (let i = 0; i < definition.length; i++) {
					txt += "<dd>\n" + definition[i] + "</dd>\n";
				}
				txt += "</dl>\n";
				return txt;
			}

			Renderer.prototype.emoji = function(quote) {
				return "&#x" + quote + ";";
			};

			Renderer.prototype.footnote = function(quote) {
				var txt = '<sup id="fnref:' + quote + '" role="doc-noteref">';
				txt += '<a class="footnote" href="#fn:' + quote + '">' + fnID + '</a>';
				txt += '</sup>';
				fnID++;
				return txt;
			};

			Renderer.prototype.blockquote = function(quote) {
				return '<blockquote>\n' + quote + '</blockquote>\n';
			};

			Renderer.prototype.html = function(html) {
				return html;
			};

			Renderer.prototype.heading = function(text, level, raw, slugger) {
				if (this.options.headerIds) {
					return '<h'
					+ level
					+ ' id="'
					+ this.options.headerPrefix
					+ slugger.slug(raw)
					+ '">'
					+ text
					+ '</h'
					+ level
					+ '>\n';
				}
				// ignore IDs
				return '<h' + level + '>' + text + '</h' + level + '>\n';
			};

			Renderer.prototype.hr = function() {
				return this.options.xhtml ? '<hr/>\n' : '<hr>\n';
			};

			Renderer.prototype.list = function(body, ordered, start) {
				var type = ordered ? 'ol' : 'ul',
				startatt = (ordered && start !== 1) ? (' start="' + start + '"') : '';
				return '<' + type + startatt + '>\n' + body + '</' + type + '>\n';
			};

			Renderer.prototype.listitem = function(text) {
				return '<li>' + text + '</li>\n';
			};

			Renderer.prototype.checkbox = function(checked) {
				return '<input '
				+ (checked ? 'checked="" ' : '')
				+ 'disabled="" type="checkbox"'
				+ (this.options.xhtml ? ' /' : '')
				+ '> ';
			};

			Renderer.prototype.paragraph = function(text) {
				var txt = '<p>' + text + '</p>';
				return txt;
			};

			Renderer.prototype.table = function(header, body) {
				if (body)
					body = '<tbody>' + body + '</tbody>';

				return '<table>\n'
				+ '<thead>\n'
				+ header
				+ '</thead>\n'
				+ body
				+ '</table>\n';
			};

			Renderer.prototype.tablerow = function(content) {
				return '<tr>\n' + content + '</tr>\n';
			};

			Renderer.prototype.tablecell = function(content, flags) {
				var type = flags.header ? 'th' : 'td';
				var tag = flags.align
				? '<' + type + ' align="' + flags.align + '">'
				: '<' + type + '>';
				return tag + content + '</' + type + '>\n';
			};

			// span level renderer
			Renderer.prototype.strong = function(text) {
				return '<strong>' + text + '</strong>';
			};

			Renderer.prototype.em = function(text) {
				return '<em>' + text + '</em>';
			};

			Renderer.prototype.codespan = function(text) {
				return '<code>' + text + '</code>';
			};

			Renderer.prototype.br = function() {
				return this.options.xhtml ? '<br/>' : '<br>';
			};

			Renderer.prototype.del = function(text) {
				return '<del>' + text + '</del>';
			};

			Renderer.prototype.link = function(href, title, text) {
				href = cleanUrl(this.options.sanitize, this.options.baseUrl, href);
				if (href === null) {
					return text;
				}
				if (href != "" && href.indexOf("http://") != 0 && href.indexOf("https://") != 0 && href.indexOf("#") != 0) {
					if (href.substring(0, 1) != "/")
						href = "/" + href;
					href = localpath + href;
				}
				var out = '<a href="' + escape(href) + '"';
				if (title) {
					out += ' title="' + title + '"';
				}
				out += '>' + text + '</a>';
				return out;
			};

			Renderer.prototype.image = function(href, title, text) {
				href = cleanUrl(this.options.sanitize, this.options.baseUrl, href);
				if (href === null) {
					return text;
				}

				if (href != "" && href.indexOf("http://") != 0 && href.indexOf("https://") != 0) {
					if (href.substring(0, 1) != "/")
						href = "/" + href;
					href = localpath + href;
				}

				var out = '<img src="' + href + '" alt="' + text + '"';
				if (title) {
					out += ' title="' + title + '"';
				}
				out += this.options.xhtml ? '/>' : '>';
				return out;
			};

			Renderer.prototype.text = function(text) {
				return text;
			};

/**
* TextRenderer
* returns only the textual part of the token
*/

			function TextRenderer()
			{
			}

			// no need for block level renderers

			TextRenderer.prototype.strong =
			TextRenderer.prototype.em =
			TextRenderer.prototype.codespan =
			TextRenderer.prototype.del =
			TextRenderer.prototype.text = function (text) {
				return text;
			};

			TextRenderer.prototype.link =
			TextRenderer.prototype.image = function(href, title, text) {
				return '' + text;
			};

			TextRenderer.prototype.br = function() {
				return '';
			};

/**
* Parsing & Compiling
*/

			function Parser(options)
			{
				this.tokens = [];
				this.token = null;
				this.options = options || marked.defaults;
				this.options.renderer = this.options.renderer || new Renderer();
				this.renderer = this.options.renderer;
				this.renderer.options = this.options;
				this.slugger = new Slugger();
			}

/**
* Static Parse Method
*/

			Parser.parse = function(src, options) {
				var parser = new Parser(options);
				return parser.parse(src);
			};

/**
* Parse Loop
*/

			Parser.prototype.parse = function(src) {
				this.inline = new InlineLexer(src.links, this.options);
				// use an InlineLexer with a TextRenderer to extract pure text
				this.inlineText = new InlineLexer(
				src.links,
				merge({}, this.options, {renderer: new TextRenderer()})
				);
				this.tokens = src.reverse();

				var out = '';
				while (this.next()) {
					out += this.tok();
				}

out += footnoteFull + footnoteFoot;
				return out;
			};

/**
* Next Token
*/

			Parser.prototype.next = function() {
				return this.token = this.tokens.pop();
			};

/**
* Preview Next Token
*/

			Parser.prototype.peek = function() {
				return this.tokens[this.tokens.length - 1] || 0;
			};

/**
* Parse Text Tokens
*/

			Parser.prototype.parseText = function() {
				var body = this.token.text;

				while (this.peek().type === 'text') {
					body += '\n' + this.next().text;
				}

				return this.inline.output(body);
			};

/**
* Parse Current Token
*/

			Parser.prototype.tok = function() {
				switch (this.token.type) {
					case 'space': {
							return '';
						}
					case 'hr': {
							return this.renderer.hr();
						}
					case 'heading': {
							return this.renderer.heading(
							this.inline.output(this.token.text),
							this.token.depth,
							unescape(this.inlineText.output(this.token.text)),
							this.slugger);
						}
					case 'footnotelink': {
							var txt = this.inline.output(this.token.text);
							return this.renderer.footnotelink(txt,
							this.token.lang,
							this.token.escaped);
						}						
					case 'code': {
						    //var txt = this.inline.output(this.token.text);
							return this.renderer.code(this.token.text,
							this.token.lang,
							this.token.escaped);
						}
					case 'definition': {
										
							for (let i = 0; i < this.token.definition.length; i++) {
								this.token.definition[i] = this.inline.output(this.token.definition[i]);
							}
							return this.renderer.definition(this.token.term, 
							this.token.definition);
						}						
					case 'emoji': {
							return this.renderer.emoji(this.token.text,
							this.token.lang,
							this.token.escaped);
						}
					case 'footnote': {
							return this.renderer.footnote(this.token.text,
							this.token.lang,
							this.token.escaped);
						}
					case 'table': {
							var header = '',
							body = '',
							i,
							row,
							cell,
							j;

							// header
							cell = '';
							for (i = 0; i < this.token.header.length; i++) {
								cell += this.renderer.tablecell(
								this.inline.output(this.token.header[i]),
								{ header: true, align: this.token.align[i] }
								);
							}
							header += this.renderer.tablerow(cell);

							for (i = 0; i < this.token.cells.length; i++) {
								row = this.token.cells[i];

								cell = '';
								for (j = 0; j < row.length; j++) {
									cell += this.renderer.tablecell(
									this.inline.output(row[j]),
									{ header: false, align: this.token.align[j] }
									);
								}

								body += this.renderer.tablerow(cell);
							}
							return this.renderer.table(header, body);
						}
					case 'blockquote_start': {
							body = '';

							while (this.next().type !== 'blockquote_end') {
								body += this.tok();
							}
							return this.renderer.blockquote(body);
						}
					case 'list_start': {
							body = '';
							var ordered = this.token.ordered,
							start = this.token.start;

							while (this.next().type !== 'list_end') {
								body += this.tok();
							}

							return this.renderer.list(body, ordered, start);
						}
					case 'list_item_start': {
							body = '';
							var loose = this.token.loose;

							if (this.token.task) {
								body += this.renderer.checkbox(this.token.checked);
							}

							while (this.next().type !== 'list_item_end') {
								body += !loose && this.token.type === 'text'
								? this.parseText()
								: this.tok();
							}

							return this.renderer.listitem(body);
						}
					case 'html': {
							// TODO parse inline content if parameter markdown=1
							return this.renderer.html(this.token.text);
						}
					case 'paragraph': {
							return this.renderer.paragraph(this.inline.output(this.token.text));
						}
					case 'text': {
							return this.renderer.paragraph(this.parseText());
						}
					default: {
							var errMsg = 'Token with "' + this.token.type + '" type was not found.';
							if (this.options.silent) {
								console.log(errMsg);
							} else {
								throw new Error(errMsg);
							}
						}
				}
			};

/**
* Slugger generates header id
*/

			function Slugger ()
			{
				this.seen = {};
			}

/**
* Convert string to unique id
*/

			Slugger.prototype.slug = function (value) {
				var slug = value
				.toLowerCase()
				.replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,.\/:;<=>?@[\]^`{|}~]/g, '')
				.trim()
				.replace(/\s/g, '-');

				if (this.seen.hasOwnProperty(slug)) {
					var originalSlug = slug;
					do {
						this.seen[originalSlug]++;
						slug = originalSlug + '-' + this.seen[originalSlug];
					} while (this.seen.hasOwnProperty(slug));
				}
				this.seen[slug] = 0;

				return slug;
			};

/**
* Helpers
*/

			function escape(html, encode)
			{
				if (encode) {
					if (escape.escapeTest.test(html)) {
						return html.replace(escape.escapeReplace, function (ch) { return escape.replacements[ch]; });
					}
				} else {
					if (escape.escapeTestNoEncode.test(html)) {
						return html.replace(escape.escapeReplaceNoEncode, function (ch) { return escape.replacements[ch]; });
					}
				}

				return html;
			}

			escape.escapeTest = /[&<>"']/;
			escape.escapeReplace = /[&<>"']/g;
			escape.replacements = {
				'&': '&amp;',
				'<': '&lt;',
				'>': '&gt;',
				'"': '&quot;',
				"'": '&#39;'
			};

			escape.escapeTestNoEncode = /[<>"']|&(?!#?\w+;)/;
			escape.escapeReplaceNoEncode = /[<>"']|&(?!#?\w+;)/g;

			function unescape(html)
			{
				// explicitly match decimal, hex, and named HTML entities
				return html.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig, function(_, n) {
					n = n.toLowerCase();
					if (n === 'colon')
						return ':';
					if (n.charAt(0) === '#') {
						return n.charAt(1) === 'x'
						? String.fromCharCode(parseInt(n.substring(2), 16))
						: String.fromCharCode(+n.substring(1));
					}
					return '';
				});
			}

			function edit(regex, opt)
			{
				regex = regex.source || regex;
				opt = opt || '';
				return {
					replace: function(name, val) {
						val = val.source || val;
						val = val.replace(/(^|[^\[])\^/g, '$1');
						regex = regex.replace(name, val);
						return this;
					},
					getRegex: function() {
						return new RegExp(regex, opt);
					}
				};
			}

			function cleanUrl(sanitize, base, href)
			{
				if (sanitize) {
					try {
						var prot = decodeURIComponent(unescape(href))
						.replace(/[^\w:]/g, '')
						.toLowerCase();
					} catch (e) {
						return null;
					}
					if (prot.indexOf('javascript:') === 0 || prot.indexOf('vbscript:') === 0 || prot.indexOf('data:') === 0) {
						return null;
					}
				}
				if (base && !originIndependentUrl.test(href)) {
					href = resolveUrl(base, href);
				}
				try {
					href = encodeURI(href).replace(/%25/g, '%');
				} catch (e) {
					return null;
				}
				return href;
			}

			function resolveUrl(base, href)
			{
				if (!baseUrls[' ' + base]) {
					// we can ignore everything in base after the last slash of its path component,
					// but we might need to add _that_
					// https://tools.ietf.org/html/rfc3986#section-3
					if (/^[^:]+:\/*[^/]*$/.test(base)) {
						baseUrls[' ' + base] = base + '/';
					} else {
						baseUrls[' ' + base] = rtrim(base, '/', true);
					}
				}
				base = baseUrls[' ' + base];

				if (href.slice(0, 2) === '//') {
					return base.replace(/:[\s\S]*/, ':') + href;
				} else if (href.charAt(0) === '/') {
					return base.replace(/(:\/*[^/]*)[\s\S]*/, '$1') + href;
			} else {
				return base + href;
			}
		}
		var baseUrls = {};
		var originIndependentUrl = /^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;

		function noop()
		{
		}
		noop.exec = noop;

		function merge(obj)
		{
			var i = 1,
			target,
			key;

			for (; i < arguments.length; i++) {
				target = arguments[i];
				for (key in target) {
					if (Object.prototype.hasOwnProperty.call(target, key)) {
						obj[key] = target[key];
					}
				}
			}

			return obj;
		}

		function splitCells(tableRow, count)
		{
			// ensure that every cell-delimiting pipe has a space
			// before it to distinguish it from an escaped pipe
			var row = tableRow.replace(/\|/g, function (match, offset, str) {
				var escaped = false,
				curr = offset;
				while (--curr >= 0 && str[curr] === '\\')
					escaped = !escaped;
				if (escaped) {
					// odd number of slashes means | is escaped
					// so we leave it alone
					return '|';
				} else {
					// add space before unescaped |
					return ' |';
				}
			}),
			cells = row.split(/ \|/),
			i = 0;

			if (cells.length > count) {
				cells.splice(count);
			} else {
				while (cells.length < count)
					cells.push('');
			}

			for (; i < cells.length; i++) {
				// leading or trailing whitespace is ignored per the gfm spec
				cells[i] = cells[i].trim().replace(/\\\|/g, '|');
			}
			return cells;
		}

		// Remove trailing 'c's. Equivalent to str.replace(/c*$/, '').
		// /c*$/ is vulnerable to REDOS.
		// invert: Remove suffix of non-c chars instead. Default falsey.
		function rtrim(str, c, invert)
		{
			if (str.length === 0) {
				return '';
			}

			// Length of suffix matching the invert condition.
			var suffLen = 0;

			// Step left until we fail to match the invert condition.
			while (suffLen < str.length) {
				var currChar = str.charAt(str.length - suffLen - 1);
				if (currChar === c && !invert) {
					suffLen++;
				} else if (currChar !== c && invert) {
					suffLen++;
				} else {
					break;
				}
			}

			return str.substr(0, str.length - suffLen);
		}

		function findClosingBracket(str, b)
		{
			if (str.indexOf(b[1]) === -1) {
				return -1;
			}
			var level = 0;
			for (var i = 0; i < str.length; i++) {
				if (str[i] === '\\') {
					i++;
				} else if (str[i] === b[0]) {
					level++;
					continue;
				} else if (str[i] === b[1]) {
					level--;
					if (level < 0) {
						return i;
					}
				}
			}
			return -1;
		}

/**
* Marked
*/

		function marked(src, opt, callback)
		{
			// throw error in case of non string input
			if (typeof src === 'undefined' || src === null) {
				throw new Error('marked(): input parameter is undefined or null');
			}
			if (typeof src !== 'string') {
				throw new Error('marked(): input parameter is of type '
				+ Object.prototype.toString.call(src) + ', string expected');
			}

			if (callback || typeof opt === 'function') {
				if (!callback) {
					callback = opt;
					opt = null;
				}

				opt = merge({}, marked.defaults, opt || {});

				var highlight = opt.highlight,
				tokens,
				pending,
				i = 0;

				try {
					tokens = Lexer.lex(src, opt);
				} catch (e) {
					return callback(e);
				}

				pending = tokens.length;

				var done = function(err) {
					if (err) {
						opt.highlight = highlight;
						return callback(err);
					}

					var out;

					try {
						out = Parser.parse(tokens, opt);
					} catch (e) {
						err = e;
					}

					opt.highlight = highlight;

					return err
					? callback(err)
					: callback(null, out);
				};

				if (!highlight || highlight.length < 3) {
					return done();
				}

				delete opt.highlight;

				if (!pending)
					return done();

				for (; i < tokens.length; i++) {
					(function(token) {
						if (token.type !== 'code') {
							return --pending || done();
						}
						return highlight(token.text, token.lang, function(err, code) {
							if (err)
								return done(err);
							if (code == null || code === token.text) {
								return --pending || done();
							}
							token.text = code;
							token.escaped = true;
							--pending || done();
						});
					})(tokens[i]);
				}

				return;
			}
			try {
				if (opt)
					opt = merge({}, marked.defaults, opt);
				return Parser.parse(Lexer.lex(src, opt), opt);
			} catch (e) {
				e.message += '\nPlease report this to https://github.com/markedjs/marked.';
				if ((opt || marked.defaults).silent) {
					return '<p>An error occurred:</p><pre>'
					+ escape(e.message + '', true)
					+ '</pre>';
				}
				throw e;
			}
		}

/**
* Options
*/

		marked.options =
		marked.setOptions = function(opt) {
			merge(marked.defaults, opt);
			return marked;
		};

		marked.getDefaults = function () {
			return {
				baseUrl: null,
				breaks: false,
				gfm: true,
				headerIds: true,
				headerPrefix: '',
				highlight: null,
				langPrefix: 'language-',
				mangle: true,
				pedantic: false,
				renderer: new Renderer(),
				sanitize: false,
				sanitizer: null,
				silent: false,
				smartLists: false,
				smartypants: false,
				tables: true,
				xhtml: false
			};
		};

		marked.defaults = marked.getDefaults();

/**
* Expose
*/

		marked.Parser = Parser;
		marked.parser = Parser.parse;

		marked.Renderer = Renderer;
		marked.TextRenderer = TextRenderer;

		marked.Lexer = Lexer;
		marked.lexer = Lexer.lex;

		marked.InlineLexer = InlineLexer;
		marked.inlineLexer = InlineLexer.output;

		marked.Slugger = Slugger;

		marked.parse = marked;

		if (typeof module !== 'undefined' && typeof exports === 'object') {
			module.exports = marked;
		} else if (typeof define === 'function' && define.amd) {
			define(function() { return marked; });
		} else {
			root.marked = marked;
		}
	})(this || (typeof window !== 'undefined' ? window : global));